Subject: Create better indexes for EM

Description

Hello Core-Team,

| have changed an index for em. Here are the result (before and after)

| 310.49219400 | SELECT SQL_NO_CACHE extension_key, max(integer_version) as maxintversion FROM

tx_extensionmanager_domain_model_extension WHERE repository=1 GROUP BY extension_key

| 4]0.17256100 | SELECT SQL_NO_CACHE extension_key, max(integer_version) as maxintversion FROM

tx_extensionmanager_domain_model_extension WHERE repository=1 GROUP BY extension_key

In general | would prefer to remove or move col "repository” to the end of an index

Stefan

Related issues:
related to Core - Bug # 59824: Better index for determineSiteRoot

Resolved

2014-06-23
[BUGFIX] EM using bad indexes

The extensionmanager uses bad indexes. It is better

to move col repository to the the end of the indexes.

Resolves: #59809

Releases: 6.3,6.2

Change-Id: 10bb8d5cdfc8591bb35485b204ad5e8dafd 1b4d16
Reviewed-on: http://review.typo3.org/32334

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>

History

#1 - 2014-06-23 15:47 - Stefan Froemken

And another one

change review_state with current_version:

| 1] 0.00045700 | SELECT COUNT(*) FROM tx_extensionmanager_domain_model_extension WHERE
(tx_extensionmanager_domain_model_extension.current_version = '1' AND tx_extensionmanager_domain_model_extension.review_state >=
1)

| 210.01897600 | SELECT COUNT(*) FROM tx_extensionmanager_domain_model_extension WHERE
(tx_extensionmanager_domain_model_extension.current_version = '1" AND tx_extensionmanager_domain_model_extension.review_state >=
1)1

| 310.00029400 | SELECT COUNT(*) FROM tx_extensionmanager_domain_model_extension WHERE

(tx_extensionmanager_domain_model_extension.current_version = '1' AND tx_extensionmanager_domain_model_extension.review_state >=

)]

1 = current
2 = without any index
3 = modified index

Stefan

#2 - 2014-06-23 17:20 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/31080

#3 - 2014-06-23 18:01 - Markus Klein

Wow, impressive. Do you have a technical reasoning why switching the order of the index, helps so much?

#4 - 2014-06-23 18:40 - Stefan Froemken
It is absolutely necessary to reduce the amount of selected rows as fast as you can within your index. In your case "repository" was the first field of
index, but in standard environment all rows have repository=1. So after processing 32.000 records we have again 32.000 records. And that's the

problem.

Please have also a look onto col "rows" in EXPLAIN of this statement. As smaller it is as faster the query is.

#5 - 2014-06-23 18:48 - Markus Klein

Gotcha now! Thx.

#6 - 2014-06-24 00:42 - Nicole Cordes

Could you explain what you did to get that query!? | don't get it and IMHO the change slows down the list view of the extension manager.

#7 - 2014-06-24 00:49 - Markus Klein

| didn't measure it, but after applying the patch, updating the table and optimizing it, | had the feeling it is faster.

#8 - 2014-06-24 00:55 - Markus Klein

According to http://en.wikipedia.org/wiki/Database_index#Column_order this really makes sense.

If we happen to have more than one repository though, we will loose speed again.

Thinking about this again, | even suggest to simply drop the repository from the index, this will also minimize the index size.

#9 - 2014-06-24 09:03 - Stefan Froemken

| have added following line to my.cnf

log_slow_queries = /var/log/mysql/mysql-slow.log

long_query_time =0

log-queries-not-using-indexes

Then analyze this file with "mysqldumpslow". F.E:

./mysqgldumpslow -t 50 -s r -a -r /var/log/mysql/mysql-slow.log

Stefan

#10 - 2014-08-23 18:15 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32334

#11 - 2014-08-23 18:30 - Stefan Froemken
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:81cee53d94e90a8b9a320641e7e949a62448b5a7.
